<?php
namespace FiloBlu\Flow\Model\From;


abstract class AbstractFrom extends \Magento\Framework\Model\AbstractModel {

    const PRODUCT_NOT_FOUND_META_STATUS = -2;

    abstract public function process();

    public function setProcessed() {
        $now = date();
        $this->setMetaProcessed(true)
            ->setMetaProcessTime($now);
        return $this;
    }

    protected function error($blocking, $msg) {
        if ($blocking) {
            throw new \Exception($msg);
        } else {
            $this->setErrorMessage($msg);
            return false;
        }
    }

    public function processFileRows($file) {

        $connection = $this->getResource()->getConnection();

        $rows = $this->getCollection()
            ->addFieldToFilter('meta_file',$file->getId())
            ->addFieldToFilter('meta_processed',0)
            ->setOrder("meta_ref_id","ASC");

        $query = $connection->query((String)$rows->getSelect());
        //$connection->beginTransaction();
        foreach($query->fetchAll() as $row){
            try{
                $this->setData($row);
                $this->process();
                $connection->query("Update " . $this->getResource()->getMainTable() . " set meta_processed = 1 where meta_id = ".$row["meta_id"]);
            }catch(\Exception $e){
                //$connection->rollback();
                $message = 'processing item '.$row["meta_id"].': '.$e->getMessage();
                throw new \Exception($message);
            }
        }
        //$connection->commit();

    }

}